/*
 * ConvertisseurGUI.java
 *
 * Created on 5 septembre 2007, 19:55
 */

package convertisseur;

import convertisseur.images.StreamLocator;
import convertisseur.listeners.FocusGained;
import convertisseur.listeners.TextChanged;
import convertisseur.metier.Calcul;
import java.awt.Graphics;
import java.awt.Image;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;
import java.awt.image.ImageObserver;
import java.awt.image.ImageProducer;
import java.math.BigInteger;
import java.util.Iterator;
import javax.swing.ImageIcon;
import javax.swing.JTextField;
import javax.swing.text.AbstractDocument;

/**
 *
 * @author  vincent
 */
public class ConvertisseurGUI extends javax.swing.JFrame {
    
    private Calcul calcul;
    private BigInteger valeur;
    private JTextField[] jtft;
    
    /** Creates new form ConvertisseurGUI */
    public ConvertisseurGUI() {
        this.jtft = new JTextField[3];
        this.calcul = new Calcul();
        
        initComponents();
        System.out.println(StreamLocator.getRessource("icone.png"));
        this.setIconImage(new ImageIcon(StreamLocator.getRessource("icone.png")).getImage());
        
        this.jtft[Calcul.BIN] = tfBin;
        this.jtft[Calcul.DEC] = tfDec;
        this.jtft[Calcul.HEX] = tfHex;
       
        this.setDefaultCloseOperation(EXIT_ON_CLOSE);
       
        this.setLocationByPlatform(true);
        
        addWindowListener( new WindowAdapter() {
            public void windowOpened( WindowEvent e ){
                tfDec.requestFocus();
            }
        } );
        
        FocusGained fg = new FocusGained();
        this.tfBin.addFocusListener(fg);
        this.tfDec.addFocusListener(fg);
        this.tfHex.addFocusListener(fg);
        
        this.tfBin.addKeyListener(new TextChanged(this,Calcul.BIN));
        this.tfDec.addKeyListener(new TextChanged(this,Calcul.DEC));
        this.tfHex.addKeyListener(new TextChanged(this,Calcul.HEX));
    }
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc=" Generated Code ">//GEN-BEGIN:initComponents
    private void initComponents() {
        labDec = new javax.swing.JLabel();
        tfDec = new javax.swing.JTextField();
        tfHex = new javax.swing.JTextField();
        labHex = new javax.swing.JLabel();
        labBin = new javax.swing.JLabel();
        tfBin = new javax.swing.JTextField();

        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);
        setTitle("Convertisseur");
        setResizable(false);
        labDec.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);
        labDec.setText("D\u00e9cimal");

        tfDec.setText("0");

        tfHex.setText("0");

        labHex.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);
        labHex.setText("Hexa.");

        labBin.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);
        labBin.setText("Binaire");

        tfBin.setText("0");

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                    .addComponent(labHex, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addComponent(labDec, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addComponent(labBin, javax.swing.GroupLayout.Alignment.TRAILING))
                .addGap(4, 4, 4)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                    .addComponent(tfDec, javax.swing.GroupLayout.DEFAULT_SIZE, 338, Short.MAX_VALUE)
                    .addComponent(tfBin, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, 338, Short.MAX_VALUE)
                    .addComponent(tfHex, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, 338, Short.MAX_VALUE))
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(labBin)
                    .addComponent(tfBin, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(labDec)
                    .addComponent(tfDec, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(tfHex, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(labHex))
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );
        pack();
    }// </editor-fold>//GEN-END:initComponents
    
    /**
     * @param args the command line arguments
     */
    public static void main(String args[]) {
        java.awt.EventQueue.invokeLater(new Runnable() {
            public void run() {
                new ConvertisseurGUI().setVisible(true);
            }
        });
    }

    public void update(int type) {
        valeur = calcul.getValue(jtft[type].getText(),type);
        if(valeur != null){
            if(type != Calcul.BIN)
                tfBin.setText(valeur.toString(2));
            if(type != Calcul.DEC)
                tfDec.setText(valeur.toString(10));
            if(type != Calcul.HEX)
                tfHex.setText(valeur.toString(16).toUpperCase());
        }
    }
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JLabel labBin;
    private javax.swing.JLabel labDec;
    private javax.swing.JLabel labHex;
    private javax.swing.JTextField tfBin;
    private javax.swing.JTextField tfDec;
    private javax.swing.JTextField tfHex;
    // End of variables declaration//GEN-END:variables
    
}
